USE [AdventureWorks]
GO
/****** Object:  StoredProcedure [dbo].[GetTabularCustomerVSVendor]   Script Date: 10/09/2012 12:04:22 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROC [dbo].[GetTabularCustomerVSVendor]  
	@VendorCount int = 5
AS  

/*
DECLARE @VendorCount int
SET @VendorCount = 7
*/
------------------------------------------------------------------------------------------------------------------------
DECLARE @SQLColumns nvarchar(max);
DECLARE @SQLSelection nvarchar(max);
DECLARE @SQLAlias nvarchar(max);
SET @SQLColumns = ''
SET @SQLSelection= ''
SET @SQLAlias = ''

DECLARE @iRowNo int, @dRoleID int, @RoleName varchar(50), @sanitizeRoleName varchar(100)

DECLARE role_Cursor CURSOR FAST_FORWARD
FOR

SELECT rank() OVER (ORDER BY VendorID) as rowNo,
VendorID, Name  FROM Purchasing.Vendor
WHERE VendorID <= @VendorCount --dummy

OPEN role_Cursor
FETCH NEXT FROM role_Cursor
INTO @iRowNo, @dRoleID, @RoleName
WHILE @@FETCH_STATUS = 0
	BEGIN
		-- sanitize the dynamic content
		SET @sanitizeRoleName = REPLACE(@RoleName,'''','''''')

		SET @SQLColumns = @SQLColumns + '[' +  Cast(@dRoleID as nvarchar(50)) + '] AS ''' + @sanitizeRoleName + ''''
		SET @SQLSelection = @SQLSelection + '[' +  Cast(@dRoleID as nvarchar(50)) + ']'
		SET @SQLAlias = @SQLAlias + '[' +  @RoleName + ']'
		
		if @iRowNo <> @VendorCount
			BEGIN
				SET @SQLColumns = @SQLColumns + ', '
				SET @SQLSelection = @SQLSelection + ', '
				SET @SQLAlias = @SQLAlias + ', '
			END
		ELSE
			BEGIN
				SET @SQLColumns = @SQLColumns + ' '
				SET @SQLSelection = @SQLSelection + ' '
				SET @SQLAlias = @SQLAlias + ' '
			END
		
		FETCH NEXT FROM role_Cursor
		INTO @iRowNo, @dRoleID, @RoleName
	END
CLOSE role_Cursor
DEALLOCATE role_Cursor
------------------------------------------------------------------------------------------------------------------------
--PRINT @SQLColumns
--PRINT @SQLSelection
--PRINT @SQLAlias
------------------------------------------------------------------------------------------------------------------------
DECLARE @SQLString nvarchar(max);
DECLARE @ParmDefinition nvarchar(500);

SET @SQLString =
     N'
;with nest(EmployeeID, ManagerID, GENERATION, hierarchy) as 
(
	Select EmployeeID, ManagerID, 
		0 as GENERATION, CAST(COALESCE(ManagerID,  EmployeeID ) as nvarchar(150)) as hierarchy  
		from HumanResources.Employee
	where  ManagerID IS NULL 
	
	union all
	
	select e.EmployeeID, e.ManagerID, 
		GENERATION+1, cast(nest.hierarchy + '' -> '' + CAST(e.EmployeeID as nvarchar(150)) as nvarchar(150)) 
		from HumanResources.Employee as e 
	inner join nest on e.ManagerID = nest.EmployeeID
)
--------------------------------------------------------------------------------------------------------
Select rank() OVER (ORDER BY hierarchy) as rowNo,--use rowNo to differentiate same hierarchy with diff Property
a.GENERATION, a.hierarchy, a.EmployeeID, c.LoginID, 
' + @SQLAlias + ' from 
(
	select GENERATION, ManagerID, EmployeeID, hierarchy from nest
) a
--inner join 
left outer join 
(
	SELECT EmployeeID, ' + @SQLColumns + ' FROM 
	(
		SELECT PurchaseOrderID, EmployeeID, VendorID
		FROM Purchasing.PurchaseOrderHeader
	) p
	PIVOT
	(
		COUNT (PurchaseOrderID) FOR VendorID  IN
		( ' + @SQLSelection + ' )
	) AS pvt
) b on a.EmployeeID = b.EmployeeID
inner join HumanResources.Employee c on a.EmployeeID = c.EmployeeID
order by a.hierarchy, a.GENERATION, a.ManagerID, a.EmployeeID 
     '
     
--PRINT @SQLString
SET @ParmDefinition = N'@VendorCount int';
EXECUTE sp_executesql @SQLString, @ParmDefinition, @VendorCount = @VendorCount